/* main.c */
#include "global.h"
#include <stdlib.h>

/*    */
const TCHAR szWindowClassName[] = "WINCLASS1";
const TCHAR szWindowTitle[] = " ";

/*   */
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (msg) {
		case WM_CREATE:
			break;

		case WM_PAINT:
			hdc = BeginPaint(hwnd,&ps);
			EndPaint(hwnd,&ps);
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0;
}

/* WinMain */
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX WndClass;
	HWND hWnd;
	MSG msg;

	/*     */
	memset(&WndClass,0,sizeof(WNDCLASSEX));
	WndClass.cbSize = sizeof(WNDCLASSEX);
	WndClass.style = CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	WndClass.lpfnWndProc = WindowProc;
	WndClass.hInstance = hInst;
	WndClass.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);
	WndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	WndClass.lpszClassName = szWindowClassName;
	WndClass.hIconSm = LoadIcon(NULL,IDI_APPLICATION);

	/*    */
	if (!RegisterClassEx(&WndClass))
		return 0;

	/*   */
	hWnd = CreateWindowEx(0,szWindowClassName,szWindowTitle,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInst,NULL);
	if (!hWnd)
		return 0;

	/*   */
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*    */
	msg.message = WM_NULL;
	while (msg.message != WM_QUIT) {
		HDC hdc;
		HBRUSH hbrush;
		RECT rect,rect_wnd;
		int fill;

		/*   ,    */
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			/*    */
			continue;
		}

		/*    */
		GetClientRect(hWnd,&rect_wnd);
		if (!rect_wnd.right || !rect_wnd.bottom)
			continue;

		/*   ESC */
		if (KEYDOWN(VK_ESCAPE))
			PostMessage(hWnd,WM_CLOSE,0,0);

		/*     */
		fill = (rand() % 3 < 1) ? 1 : 0;

		if (fill) {
			rect_wnd.right++;
			rect_wnd.bottom++;
		}

		/*   */
		rect.left = rand() % rect_wnd.right;
		rect.top = rand() % rect_wnd.bottom;
		rect.right = rand() % rect_wnd.right;
		rect.bottom = rand() % rect_wnd.bottom;

		/*   */
		hbrush = CreateSolidBrush(RGB(rand()%256,rand()%256,rand()%256));

		/*   */
		hdc = GetDC(hWnd);

		/*   */
		if (fill)
			FillRect(hdc,&rect,hbrush);
		else
			FrameRect(hdc,&rect,hbrush);

		/*   */
		DeleteObject(hbrush);
		ReleaseDC(hWnd,hdc);
	}

	return msg.wParam;
}
